#include "connectionlistmodel.h"

ConnectionListModel::ConnectionListModel(QObject *parent)
    : QAbstractTableModel(parent)
{

}

void ConnectionListModel::appendConnection(ConnectionList *item)
{
    ConnectionData connectionItem;
    if(!item->getAttrValue().isEmpty()){
        connectionItem[CONNECTION] = item->getAttrValue();
    }
    if(item->getContactList() != nullptr){
        m_contactMap.insert(item->getContactList()->at(0).getMap()->key("1"), item->getContactList()->at(0).getMap()->value("1"));
        m_contactMap.insert(item->getContactList()->at(0).getMap()->key("2"), item->getContactList()->at(0).getMap()->value("2"));
        m_contactList.append(m_contactMap);
        m_contactList.append(m_contactMap);
        connectionItem[CONTACTLIST] = QVariant::fromValue(m_contactList);
    }

    int row = m_connectionGroup.count();
    beginInsertRows(QModelIndex(), row, row);
    m_connectionGroup.append(connectionItem);
    endInsertRows();

}


int ConnectionListModel::rowCount(const QModelIndex &parent) const
{
    Q_UNUSED(parent)
    return m_connectionGroup.count();
}

int ConnectionListModel::columnCount(const QModelIndex &parent) const
{
    Q_UNUSED(parent)
    return COLUMNCOUNT;
}

QVariant ConnectionListModel::data(const QModelIndex &index, int role) const
{
    if(!index.isValid() ||
            m_connectionGroup.count() <= index.row() ||
            (role != Qt::DisplayRole && role != Qt::EditRole)){
        return QVariant();
    }
    return m_connectionGroup[index.row()][Columns(index.column())];
}

QVariant ConnectionListModel::headerData(int section, Qt::Orientation orientation, int role) const
{
    if(role != Qt::DisplayRole){
        return QVariant();
    }

    if(orientation == Qt::Vertical){
        return section + 1;
    }
    switch(section){
    case CONNECTION:
        return tr("CONNECTION");
    case CONTACTLIST:
        return tr("CONTACTLIST");
    }
    return QVariant();
}

Qt::ItemFlags ConnectionListModel::flags(const QModelIndex &index) const
{
    Qt::ItemFlags flags = QAbstractTableModel::flags(index);
    if(index.isValid()){
        flags |= Qt::ItemIsEditable;
    }

    return flags;
}
