#ifndef CONNECTIONLISTMODEL_H
#define CONNECTIONLISTMODEL_H

#include "connectionlist.h"

#include <QAbstractTableModel>
#include <QObject>

class ConnectionListModel : public QAbstractTableModel
{
    Q_OBJECT
public:
    ConnectionListModel(QObject *parent = nullptr);

    void appendConnection(ConnectionList *item);
    void resetModel();
    QVector<ConnectionList> getConnectionList();

private:
    enum Columns{
        CONNECTION = 0,
        CONTACTLIST,
        COLUMNCOUNT
    };

    typedef QHash<Columns, QVariant> ConnectionData;
    typedef  QMap<QString, QVariant> ContactData;
    typedef  QVariantList ContactList;
    typedef QList<ConnectionData> ConnectionGroup;
    ConnectionGroup m_connectionGroup;
    ContactData m_contactMap;
    ContactList m_contactList;



    // QAbstractItemModel interface
public:
    int rowCount(const QModelIndex &parent) const;
    int columnCount(const QModelIndex &parent) const;
    QVariant data(const QModelIndex &index, int role) const;
    QVariant headerData(int section, Qt::Orientation orientation, int role) const;
    Qt::ItemFlags flags(const QModelIndex &index) const;
};

#endif // CONNECTIONLISTMODEL_H
