#include "contactmodel.h"

ContactModel::ContactModel(QObject *parent)
    : QAbstractTableModel(parent)
{
}

QVariant ContactModel::headerData(int section, Qt::Orientation orientation, int role) const
{
    if(role != Qt::DisplayRole){
        return QVariant();
    }

    if(orientation == Qt::Vertical){
        return section + 1;
    }
    switch(section){
    case CONTACTIDENT:
        return tr("CONTACTIDENT");
    case CONTACTFUNCTION:
        return tr("CONTACTFUNCTION");
    case CONTACTTYPE:
        return tr("CONTACTTYPE");
    case CONNECTEDFLAG:
        return tr("CONNECTEDFLAG");
    case CONTACTPARTNUMBER:
        return tr("CONTACTPARTNUMBER");
    case WIREINSTALLATION:
        return tr("WIREINSTALLATION");
    }
    return QVariant();
}

int ContactModel::rowCount(const QModelIndex &parent) const
{
    Q_UNUSED(parent)
    return m_contactGroup.count();

}

int ContactModel::columnCount(const QModelIndex &parent) const
{
    Q_UNUSED(parent)
    return COLUMNCOUNT;
}


void ContactModel::appendContact(Contact *item)
{    ContactData contactItem;
     if(item->getMap()->contains("1")){
         contactItem[CONTACTIDENT] = item->getMap()->value(item->getMap()->key("1"));
     }
     if(item->getMap()->contains("2")){
         contactItem[CONTACTFUNCTION] = item->getMap()->value(item->getMap()->key("2"));
     }
     if(item->getMap()->contains("3")){
         contactItem[CONTACTTYPE] = item->getMap()->value(item->getMap()->key("3"));
     }
     if(item->getMap()->contains("4")){
         contactItem[CONNECTEDFLAG] = item->getMap()->value(item->getMap()->key("4"));
     }
     if(item->getMap()->contains("5")){
         contactItem[CONTACTPARTNUMBER] = item->getMap()->value(item->getMap()->key("5"));
     }
     if(item->getMap()->contains("6")){
         contactItem[WIREINSTALLATION] = item->getMap()->value(item->getMap()->key("6"));
     }
     int row = m_contactGroup.count();
     beginInsertRows(QModelIndex(), row, row);
     m_contactGroup.append(contactItem);
     endInsertRows();
}


Qt::ItemFlags ContactModel::flags(const QModelIndex &index) const
{
    Qt::ItemFlags flags = QAbstractTableModel::flags(index);
    if(index.isValid()){
        flags |= Qt::ItemIsEditable;
    }

    return flags;
}


QVariant ContactModel::data(const QModelIndex &index, int role) const
{
    if(!index.isValid() ||
            m_contactGroup.count() <= index.row() ||
            (role != Qt::DisplayRole && role != Qt::EditRole)){
        return QVariant();
    }
    return m_contactGroup[index.row()][Cols(index.column())];
}
