#ifndef CONTACTMODEL_H
#define CONTACTMODEL_H

#include "contact.h"

#include <QAbstractTableModel>

class ContactModel : public QAbstractTableModel
{
    Q_OBJECT

public:
    ContactModel(QObject *parent = nullptr);

    void appendContact(Contact *item);
    void resetModel();
    QVector<Contact> getContactList();

private:
    enum Cols{
        CONTACTIDENT = 0,
        CONTACTFUNCTION,
        CONTACTTYPE,
        CONNECTEDFLAG,
        CONTACTPARTNUMBER,
        WIREINSTALLATION,
        COLUMNCOUNT
    };

    typedef QHash<Cols, QVariant> ContactData;
    typedef QList<ContactData> ContactGroup;
    ContactGroup m_contactGroup;


    // QAbstractItemModel interface
public:
    int rowCount(const QModelIndex &parent) const;
    int columnCount(const QModelIndex &parent) const;
    QVariant data(const QModelIndex &index, int role) const;

    // QAbstractItemModel interface
public:
    QVariant headerData(int section, Qt::Orientation orientation, int role) const;

    // QAbstractItemModel interface
public:
    Qt::ItemFlags flags(const QModelIndex &index) const;
};

#endif // CONTACTMODEL_H
