#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    _cModel = new ContactModel();
    ui->contactTable->setModel(_cModel);
    ui->contactTable->horizontalHeader()->resizeSections(QHeaderView::ResizeMode::ResizeToContents);

    _connListModel = new ConnectionListModel();
    ui->connectionTable->setModel(_connListModel);
    ui->connectionTable->horizontalHeader()->resizeSections(QHeaderView::ResizeMode::ResizeToContents);

    Contact *cont1 = new Contact();
    Contact *cont2 = new Contact();
    ConnectionList *newConnectionList = new ConnectionList();

    auto attrMap = new QMap<QString, QString>();
    attrMap->insert("1", "1");
    attrMap->insert("2", "2");
    attrMap->insert("3", "3");
    attrMap->insert("4", "4");
    attrMap->insert("5", "5");
    attrMap->insert("6", "6");
    cont1->setMap(attrMap);
    cont2->setMap(attrMap);
    _cModel->appendContact(cont1);
    _cModel->appendContact(cont2);

    newConnectionList->setAttrValue("direct");
    QVector<Contact> *contactList = new QVector<Contact>();
    contactList->append(*cont1);
    contactList->append(*cont2);
    newConnectionList->setContactList(contactList);
    _connListModel->appendConnection(newConnectionList);

}

MainWindow::~MainWindow()
{
    delete ui;
}
